import java.util.Random;

/**
 * Class NumList represents a list of numbers. You can create the list
 * by using add(), one at a time, or by using fillRandom.
 * Once you have a list, you can print it, or get the sum. 
 * 
 * You can get the nth value with get(n), or set the nth value with set(n, val).
 * If n is out of range, get(n) returns 0 and set(n, val) does nothing.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class NumList
{
    // instance variables - replace the example below with your own
    private int[] nums;
    private int currsize;

    /**
     * Constructor for objects of class NumList
     */
    public NumList()
    {
        // initialise instance variables
        final int defaultsize = 5;
        currsize = 0;
        nums = new int[defaultsize];
    }

    /**
     * parameter constructor
     * You *may* wish to modify this so that "new NumList(size)" also sets currsize=size;
     * see handout
     */
    public NumList(int size) {
        currsize = 0;
        nums = new int[size];
    }
       
    /**
     * Add() adds the value y to the list, at position currsize
     * (that is, at the end of the existing list).
     * The size of the list is incremented.
     * If pos = nums.length, there is no more room, so we don't do anything;
     * THAT part you are to change.
     */
    public void add(int y) {
        if (currsize == nums.length) {
            System.out.println("no more room to add " + y);
            return;
        }
        nums[currsize] = y;
        currsize += 1;      // or pos++
    }
    
    // get nth value, with range check
    public int get(int n) {
        if (n<0 || n >= currsize) {
            System.out.println("Warning: Numlist.get() called with out-of-range n = " + n);
            return 0;
        }
        return nums[n];
    }
    
    // set nth value, with range check
    public void set(int n, int val) {
        if (n<0 || n >= currsize) {
            System.out.println("Warning: Numlist.set() called with out-of-range n = " + n);
            return;
        }
        nums[n] = val;
    }
    
    public int size() {
        return currsize;
    }

    // fillRandom fills positions 0..currsize-1 with random ints < max.
    public void fillRandom(int max) {
        Random rand = new Random();
        // now get random numbers from rand.nextInt(max)
        int i=0;
        while (i<currsize) {
            nums[i] = rand.nextInt(max);
            i = i+1;
        }
    }
    
     public void print() {
         int i=0;
         while (i<currsize) {
            System.out.println(i + ":  " + nums[i]);
            i++;    // alternative shorthand for i=i+1
        }
    }
    
    // sum() returns the sum of the numbers in the array.
    public int sum() {
        int i = 0;
        int sum = 0;
        while (i<currsize) {
            sum = sum + nums[i];
            i = i+1;
        }
        return sum;   // replace this with a return of the correct value
    }
    
    /** 
     * YOU NEED TO FINISH THIS ONE
     */
    public int max() {
        if (currsize == 0) {     // array is empty... oops!
            System.out.println("can't take max() of empty array!");
            return 0;   // gotta return something
        }
        int max = nums[0];      // safer than max = 0
        // loop to set max to max of nums[0]...nums[currsize-1] goes here
        return max;
    }
 }
